MEMORY
{
   ram : ORIGIN = 0x0, LENGTH = 0x800000
   rom : ORIGIN = 0x1000000, LENGTH = 0x1000000
  iram : ORIGIN = 0x3fe0000, LENGTH = 0x2000
}


SECTIONS
{
    .text 0 : { *(.text) }     >ram
    .rodata : { *(.rodata*) } >ram
    .glue : { *(.glue*) }    >ram
    .data : { *(.data) }     >ram
    .payload : { *(.payload*) }     >ram
    .bss  : { *(.bss) }   >ram

    .stab 0 : { *(.stab) }
    .stabstr 0 : { *(.stabstr) }
    .debug_aranges  0 : { *(.debug_aranges) }
    .debug_pubnames 0 : { *(.debug_pubnames) }
    .debug_info     0 : { *(.debug_info) }
    .debug_abbrev   0 : { *(.debug_abbrev) }
    .debug_line     0 : { *(.debug_line) }
    .debug_frame    0 : { *(.debug_frame) }
    .debug_str      0 : { *(.debug_str) }
    .debug_loc      0 : { *(.debug_loc) }
    .debug_macinfo  0 : { *(.debug_macinfo) }
}

_bssStart = ADDR(.bss);
_bssLen = SIZEOF(.bss);

__payloadStart = ADDR(.payload);
__payloadEnd   = ADDR(.payload)+SIZEOF(.payload);

ENTRY(_start);

EXTACON  = 0x7ff3008;
EXTACON0 = 0x7ff3008;
EXTACON1 = 0x7ff300c;

PioMode = 0x7ff5000;
PioData = 0x7ff5008;

interfaceSelect0 = 0x7600000;
interfaceSelect1 = 0x7600001;
EpldFlashWriteEnable =  0x7600040;
vlanControl      = 0x7600041;

DallasDS1511W = 0x07608000;

aiop0 = 0x7604000;
aiop1 = 0x7604080;

ks32c5000_uart1 = 0x7ffd000;
ks32c5000_uart2 = 0x7ffe000;

stackTop = 0x7ffff0;
