/*********************************************************************
 *  iic.h  
 * 
 *  Include file for iic.c
 *  Copied from $ECOS/hal/arm/dmrts/current/include/iic.h
 *  Edited to remove unnecessary functions other than getModelNumber()
 *
 *********************************************************************/

/*  Macros which define addresses (decimal) and sizes (bytes) of IIC variables */
#define MAC_ADDRESS_ADDR        0
#define BOARD_REV_ADDR          8
#define MODEL_NUMBER_ADDR       12
#define IP_ADDRESS_ADDR         16
#define NETMASK_ADDR            20
#define GATEWAY_ADDR            24
#define PASSWORD_ADDR           32
#define AUTH_METHOD_ADDR        48
#define SERVICE_ENABLE_ADDR     49
#define TIMEOUT_ADDR            50
#define TELNET_TIMEOUT_ADDR     52
#define SERNUM_PREFIX_ADDR      56
#define SERNUM_ADDR             58
#define APP_ENABLE_KEY_ADDR     60

#define MAC_ADDRESS_SIZE        6
#define BOARD_REV_SIZE          4
#define MODEL_NUMBER_SIZE       4
#define IP_ADDRESS_SIZE         4
#define NETMASK_SIZE            4
#define GATEWAY_SIZE            4
#define PASSWORD_SIZE           16
#define AUTH_METHOD_SIZE        1
#define SERVICE_ENABLE_SIZE     1
#define TIMEOUT_SIZE            1
#define TELNET_TIMEOUT_SIZE     4
#define SERNUM_PREFIX_SIZE      2
#define SERNUM_SIZE             2
#define APP_ENABLE_KEY_SIZE     1

/* Bit map of service enable byte (address: 49) */
#define SERVICE_TELNET          0x01
#define SERVICE_SSL             0x02
#define SERVICE_SNMP            0x04

/*  Prototypes */
void getModelNumber(unsigned long *m);
