//==========================================================================
//      misc_funs.c
//      Miscellaneous [library] functions for RedBoot
//==========================================================================
//####COPYRIGHTBEGIN          REDBOOT         ####
//==========================================================================
//-------------------------------------
// Convert a character to lower case
//
__inline__ static char
tolower(char c)
{
    if ((c >= 'A') && (c <= 'Z')) {
        c = (c - 'A') + 'a';
    }
    return c;
}

//========================
int strlen(const char *s)
{
    int len = 0;
    if (s)
        while (*s++) len++;
    return len;
}

//=============================
int strcmp(const char *s1, const char *s2)
{
    char c1, c2;

    while ((c1 = *s1++) == (c2 = *s2++))
        if (c1 == 0)
            return (0);
    return ((unsigned char)c1 - (unsigned char)c2);
}

//==============================
char *strcpy(char *s1, const char *s2)
{
    char c;
    char *_s1 = s1;

    while ((c = *s2++) != '\0')
        *s1++ = c;
    *s1 = '\0';
    return _s1;
}

//================================
int strcmpci(const char *s1, const char *s2)
{
    char c1, c2;
    while ((c1 = tolower(*s1++)) == (c2 = tolower(*s2++)))
        if (c1 == 0)
            return (0);
    return ((unsigned char)c1 - (unsigned char)c2);
}

//=================================
#if (0)
int strncmp(const char *s1, const char *s2, int len)
{
    char c1, c2;

    if (len == 0)
        return 0;
    do {
        if ((c1 = *s1++) != (c2 = *s2++))
            return ((unsigned char)c1 - (unsigned char)c2);
        if (c1 == 0)
            break;
    } while (--len != 0);
    return 0;
}
#endif

//===============
void *memset(unsigned char *s, int c, unsigned long n)
{
  unsigned char *memp = s;
  while(n)
    {
      *memp = c;
      memp += 1;
      n -=1;
    }
  return s;
}

//============================================================================
