        .section .text
        
        .global main
        
__reset:                 b _start

undefined_instruction:
__undef:                 b __undef
              
software_interrupt:
__swi:                   b __swi
             
abort_prefetch:
__abortp:                b __abortp

abort_data:
__abortd:                b __abortd

undefined_vector:
__reserved:              b __reserved

IRQ:
__irq:                   b __irq

FIQ:
__fiq:                   b __fiq

        
	.global _start
        .global main
        .global stackTop
        .global __gccmain
_start:
        ldr     r1,=0x00000000                           
        ldr     r2,=0xffffffff                           

        ldr     r0,=0x7ff0000
        ldr     r3,=0x83ffffa0
        str     r3,[r0]        /* shut off cache */

        ldr     r0,=0x7ff6000                           
        str     r1,[r0]        /* disable timers */      
                                                         
        ldr     r0,=0x7ff5000                            
        str     r1,[r0,#0]     /* shut off WD */         
        str     r1,[r0,#4]     /* disable extern ints */ 
                                                         
        ldr     r0,=0x7ff4000                           
        str     r1,[r0,#0]     /* all ints IRQ mode */   
        str     r2,[r0,#8]     /* mask all interrupts */ 
        str     r2,[r0,#4]     /* ack all interrupts  */ 
                                                         
        ldr     r0,=0x7ff9000                           
        str     r1,[r0,#0]     /* shut off BDMA Rx */    
        str     r1,[r0,#4]     /* shut off BDMA Tx */    
                                                         
        ldr     r0,=0x7ffa000                           
        str     r1,[r0,#8]     /* MAC Tx off        */   
        str     r1,[r0,#16]    /* MAC Rx off        */   
        str     r1,[r0,#0]     /* reset MAC control */   

        /* zero out bss section */

	ldr	r0,=0
        ldr	r1,=_bssStart
        ldr     r2,=_bssLen
1:
	str    r0,[r1],#4
        subs   r2,r2,#4
        bgt    1b

	ldr	r0,_stackTop
        mov     sp,r0
        mov     fp,r0

        bl      main
        nop
end:
	nop
	b	end

__gccmain:
        mov     pc,lr   

_main: .word main
_stackTop: .word stackTop

        

